// gyazowin.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "gyazowin.h"

// O[oϐ:
HINSTANCE hInst;							// ݂̃C^[tFCX
TCHAR *szTitle			= _T("gyazowin");	// ^Cg o[̃eLXg
TCHAR *szWindowClass	= _T("GYAZOWIN");	// C EBhE NX

int ofX, ofY;	// ʃItZbg

// vg^Cv錾
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

int					GetEncoderClsid(const WCHAR* format, CLSID* pClsid);

BOOL				isPng(LPCTSTR fileName);
VOID				drawRubberband(HDC hdc, LPRECT newRect, BOOL erase);
VOID				execUrl(const char* str);
VOID				setClipBoardText(const char* str);
BOOL				convertPNG(LPCTSTR destFile, LPCTSTR srcFile);
BOOL				savePNG(LPCTSTR fileName, HBITMAP newBMP);
BOOL				uploadFile(HWND hwnd, LPCTSTR fileName);
std::string			getId();

// Gg[|Cg
int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	MSG msg;

	TCHAR	szThisPath[MAX_PATH];
	DWORD   sLen;

	// g̃fBNg擾
	sLen = GetModuleFileName(NULL, szThisPath, MAX_PATH);
	for(unsigned int i = sLen; i >= 0; i--) {
		if(szThisPath[i] == _T('\\')) {
			szThisPath[i] = _T('\0');
			break;
		}
	}

	// JgfBNg exe Ɠꏊɐݒ
	SetCurrentDirectory(szThisPath);

	// Ƀt@Cw肳Ă
	if ( 2 == __argc )
	{
		// t@CAbv[hďI
		if (isPng(__targv[1])) {
			// PNG ͂̂܂upload
			uploadFile(NULL, __targv[1]);
		}else {
			// PNG `ɕϊ
			TCHAR tmpDir[MAX_PATH], tmpFile[MAX_PATH];
			GetTempPath(MAX_PATH, tmpDir);
			GetTempFileName(tmpDir, _T("gya"), 0, tmpFile);
			
			if (convertPNG(tmpFile, __targv[1])) {
				//Abv[h
				uploadFile(NULL, tmpFile);
			} else {
				// PNGɕϊłȂ...
				MessageBox(NULL, _T("cannot convert this image"), _T("ERROR"), 
					MB_OK | MB_ICONERROR);
			}
			DeleteFile(tmpFile);
		}
		return TRUE;
	}

	// EBhENXo^
	MyRegisterClass(hInstance);

	// AvP[V̏s܂:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}
	
	// C bZ[W [v:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (int) msg.wParam;
}

// wb_ PNG 摜ǂ(ꉞ)`FbN
BOOL isPng(LPCTSTR fileName)
{
	unsigned char pngHead[] = { 0x89, 0x50, 0x4E, 0x47, 0x0D, 0x0A, 0x1A, 0x0A };
	unsigned char readHead[8];
	
	FILE *fp = NULL;
	
	if (0 != _tfopen_s(&fp, fileName, _T("rb")) ||
		8 != fread(readHead, 1, 8, fp)) {
		// t@Cǂ߂Ȃ	
		return FALSE;
	}
	fclose(fp);
	
	// compare
	for(unsigned int i=0;i<8;i++)
		if(pngHead[i] != readHead[i]) return FALSE;

	return TRUE;

}

// EBhENXo^
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASS wc;

	wc.style         = 0;							// WM_PAINT 𑗂Ȃ
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_GYAZOWIN));
	wc.hCursor       = LoadCursor(NULL, IDC_CROSS);	// + ̃J[\
	wc.hbrBackground = 0;							// wiݒ肵Ȃ
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}


// CX^X̏iSʂEBhEŕj
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND hWnd;
	hInst = hInstance; // O[oϐɃCX^Xi[܂B

	int x, y, w, h;

	// zXN[ŜJo[
	x = GetSystemMetrics(SM_XVIRTUALSCREEN);
	y = GetSystemMetrics(SM_YVIRTUALSCREEN);
	w = GetSystemMetrics(SM_CXVIRTUALSCREEN);
	h = GetSystemMetrics(SM_CYVIRTUALSCREEN);

	// x, y ̃ItZbgloĂ
	ofX = x; ofY = y;

	// Sɓ߂EBhE
	hWnd = CreateWindowEx(
		WS_EX_TRANSPARENT | WS_EX_TOOLWINDOW | WS_EX_TOPMOST
#if(_WIN32_WINNT >= 0x0500)
		| WS_EX_NOACTIVATE
#endif
		,
		szWindowClass, NULL, WS_POPUP,
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
		NULL, NULL, hInstance, NULL);

	// Ȃ...?
	if (!hWnd) return FALSE;
	
	// Sʂ𕢂
	MoveWindow(hWnd, x, y, w, h, FALSE);
	
	// nCmdShow 𖳎 (SW_MAXIMIZE Ƃƍ)
	ShowWindow(hWnd, SW_SHOW);
	UpdateWindow(hWnd);
	
	return TRUE;
}

// w肳ꂽtH[}bgɑΉ Encoder  CLSID 擾
// Cited from MSDN Library: Retrieving the Class Identifier for an Encoder
int GetEncoderClsid(const WCHAR* format, CLSID* pClsid)
{
   UINT  num = 0;          // number of image encoders
   UINT  size = 0;         // size of the image encoder array in bytes

   ImageCodecInfo* pImageCodecInfo = NULL;

   GetImageEncodersSize(&num, &size);
   if(size == 0)
      return -1;  // Failure

   pImageCodecInfo = (ImageCodecInfo*)(malloc(size));
   if(pImageCodecInfo == NULL)
      return -1;  // Failure

   GetImageEncoders(num, size, pImageCodecInfo);

   for(UINT j = 0; j < num; ++j)
   {
      if( wcscmp(pImageCodecInfo[j].MimeType, format) == 0 )
      {
         *pClsid = pImageCodecInfo[j].Clsid;
         free(pImageCodecInfo);
         return j;  // Success
      }    
   }

   free(pImageCodecInfo);
   return -1;  // Failure
}

// o[oh`.
VOID drawRubberband(HDC hdc, LPRECT newRect, BOOL erase)
{
	
	static BOOL firstDraw = TRUE;	// 1 ڂ͑Õoh̏sȂ
	static RECT lastRect  = {0};	// Ōɕ`悵oh
	
	// XOR ŕ`
	int hPreRop = SetROP2(hdc, R2_XORPEN);

	// _
	HPEN hPen = CreatePen(PS_DOT , 1, 0);
	SelectObject(hdc, hPen);
	SelectObject(hdc, GetStockObject(NULL_BRUSH));

	if(!firstDraw) {
		// Ô
		Rectangle(hdc, lastRect.left, lastRect.top, 
			lastRect.right + 1, lastRect.bottom + 1);
	} else {
		firstDraw = FALSE;
	}
	
	// VWL
	lastRect = *newRect;
	
	if (!erase) {

		// g`
		Rectangle(hdc, lastRect.left, lastRect.top, 
			lastRect.right + 1, lastRect.bottom + 1);

	}

	// ㏈
	SetROP2(hdc, hPreRop);
	DeleteObject(hPen);

}

// PNG `ɕϊ
BOOL convertPNG(LPCTSTR destFile, LPCTSTR srcFile)
{
	BOOL				res = FALSE;

	GdiplusStartupInput	gdiplusStartupInput;
	ULONG_PTR			gdiplusToken;
	CLSID				clsidEncoder;

	// GDI+ ̏
	GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);

	Image *b = new Image(srcFile, 0);

	if (0 == b->GetLastStatus()) {
		if (GetEncoderClsid(L"image/png", &clsidEncoder)) {
			// save!
			if (0 == b->Save(destFile, &clsidEncoder, 0) ) {
					// ۑł
					res = TRUE;
			}
		}
	}

	// n
	delete b;
	GdiplusShutdown(gdiplusToken);

	return res;
}

// PNG `ŕۑ (GDI+ gp)
BOOL savePNG(LPCTSTR fileName, HBITMAP newBMP)
{
	BOOL				res = FALSE;

	GdiplusStartupInput	gdiplusStartupInput;
	ULONG_PTR			gdiplusToken;
	CLSID				clsidEncoder;

	// GDI+ ̏
	GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);
	
	// HBITMAP  Bitmap 쐬
	Bitmap *b = new Bitmap(newBMP, NULL);
	
	if (GetEncoderClsid(L"image/png", &clsidEncoder)) {
		// save!
		if (0 ==
			b->Save(fileName, &clsidEncoder, 0) ) {
				// ۑł
				res = TRUE;
		}
	}
	
	// n
	delete b;
	GdiplusShutdown(gdiplusToken);

	return res;
}

// EBhEvV[W
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	
	static BOOL onClip		= FALSE;
	static BOOL firstDraw	= TRUE;
	static RECT clipRect	= {0, 0, 0, 0};
	
	switch (message)
	{
	
	case WM_RBUTTONDOWN:
		// LZ
		DestroyWindow(hWnd);
		return DefWindowProc(hWnd, message, wParam, lParam);
		break;

	case WM_MOUSEMOVE:
		if (onClip) {
			
			// VWZbg
			clipRect.right  = LOWORD(lParam) + ofX;
			clipRect.bottom = HIWORD(lParam) + ofY;
			
			hdc = GetDC(NULL);
			drawRubberband(hdc, &clipRect, FALSE);
			ReleaseDC(NULL, hdc);
			
			// EndPaint(hWnd, &ps);
		}
		break;
	

	case WM_LBUTTONDOWN:
		{
			// NbvJn
			onClip = TRUE;
			
			// ʒuZbg
			clipRect.left = LOWORD(lParam) + ofX;
			clipRect.top  = HIWORD(lParam) + ofY;
			
			// }EXLv`
			SetCapture(hWnd);
		}
		break;

	case WM_LBUTTONUP:
		{
			// NbvI
			onClip = FALSE;
			
			// }EX̃Lv`
			ReleaseCapture();
		
			// VWZbg
			clipRect.right  = LOWORD(lParam) + ofX;
			clipRect.bottom = HIWORD(lParam) + ofY;

			// ʂɒڕ`CČ`
			HDC hdc = GetDC(NULL);

			// 
			drawRubberband(hdc, &clipRect, TRUE);

			// W`FbN
			if ( clipRect.right  < clipRect.left ) {
				int tmp = clipRect.left;
				clipRect.left   = clipRect.right;
				clipRect.right  = tmp;
			}
			if ( clipRect.bottom < clipRect.top  ) {
				int tmp = clipRect.top;
				clipRect.top    = clipRect.bottom;
				clipRect.bottom = tmp;
			}
			
			// 摜̃Lv`
			int iWidth, iHeight;
			iWidth  = clipRect.right  - clipRect.left + 1;
			iHeight = clipRect.bottom - clipRect.top  + 1;

			if(iWidth == 0 || iHeight == 0) {
				// 摜ɂȂĂȂ, ȂɂȂ
				ReleaseDC(NULL, hdc);
				DestroyWindow(hWnd);
				break;
			}

			// rbg}bvobt@쐬
			HBITMAP newBMP = CreateCompatibleBitmap(hdc, iWidth, iHeight);
			HDC	    newDC  = CreateCompatibleDC(hdc);
			
			// ֘AÂ
			SelectObject(newDC, newBMP);

			// 摜擾
			BitBlt(newDC, 0, 0, iWidth, iHeight, 
				hdc, clipRect.left, clipRect.top, SRCCOPY);
			
			// EBhEB!
			ShowWindow(hWnd, SW_HIDE);
			
			/*
			// 摜Nbv{[hɃRs[
			if ( OpenClipboard(hWnd) ) {
				// 
				EmptyClipboard();
				// Zbg
				SetClipboardData(CF_BITMAP, newBMP);
				// 
				CloseClipboard();
			}
			*/
			
			// e|t@C
			TCHAR tmpDir[MAX_PATH], tmpFile[MAX_PATH];
			GetTempPath(MAX_PATH, tmpDir);
			GetTempFileName(tmpDir, _T("gya"), 0, tmpFile);
			
			if (savePNG(tmpFile, newBMP)) {

				// 
				if (!uploadFile(hWnd, tmpFile)) {
					// Abv[hɎs...
					// G[bZ[W͊ɕ\Ă

					/*
					TCHAR sysDir[MAX_PATH];
					if (SUCCEEDED(StringCchCopy(sysDir, MAX_PATH, tmpFile)) &&
						SUCCEEDED(StringCchCat(sysDir, MAX_PATH, _T(".png")))) {
						
						MoveFile(tmpFile, sysDir);
						SHELLEXECUTEINFO lsw = {0};
						
						lsw.hwnd	= hWnd;
						lsw.cbSize	= sizeof(SHELLEXECUTEINFO);
						lsw.lpVerb	= _T("open");
						lsw.lpFile	= sysDir;

						ShellExecuteEx(&lsw);
					}
					*/
				}
			} else {
				// PNGۑs...
				MessageBox(hWnd, _T("cannot save png image"), _T("ERROR"), 
					MB_OK | MB_ICONERROR);
			}

			// n
			DeleteFile(tmpFile);
			
			DeleteDC(newDC);
			DeleteObject(newBMP);

			ReleaseDC(NULL, hdc);
			DestroyWindow(hWnd);
		}
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Nbv{[hɕRs[
VOID setClipBoardText(const char* str)
{

	HGLOBAL hText;
	char    *pText;
	size_t  slen;

	slen  = strlen(str) + 1; // NULL

	hText = GlobalAlloc(GMEM_DDESHARE | GMEM_MOVEABLE, slen * sizeof(TCHAR));

	pText = (char *)GlobalLock(hText);
	strncpy_s(pText, slen, str, slen);
	GlobalUnlock(hText);
	
	// Nbv{[hJ
	OpenClipboard(NULL);
	EmptyClipboard();
	SetClipboardData(CF_TEXT, hText);
	CloseClipboard();

	// 
	GlobalFree(hText);
}

// w肳ꂽ URL (char*) uEUŊJ
VOID execUrl(const char* str)
{
	size_t  slen;
	size_t  dcount;
	slen  = strlen(str) + 1; // NULL

	TCHAR *wcUrl = (TCHAR *)malloc(slen * sizeof(TCHAR));
	
	// Chɕϊ
	mbstowcs_s(&dcount, wcUrl, slen, str, slen);
	
	// open R}hs
	SHELLEXECUTEINFO lsw = {0};
	lsw.cbSize = sizeof(SHELLEXECUTEINFO);
	lsw.lpVerb = _T("open");
	lsw.lpFile = wcUrl;

	ShellExecuteEx(&lsw);

	free(wcUrl);
}

// ID 𐶐E[h
std::string getId()
{
	const char*	 idFile			= "id.txt";
	std::string idStr;

	// ܂̓t@C ID [h
	std::ifstream ifs;

	ifs.open(idFile);
	if (! ifs.fail()) {
		// ID ǂݍ
		ifs >> idStr;
		ifs.close();
	} else{
		// defaultݒ: t(strftime)
		char		timebuf[64];
		struct tm	dt;
		time_t		now	= time(NULL);

		localtime_s(&dt, &now);
		strftime(timebuf, 64, "%Y%m%d%H%M%S", &dt);
		
		// ID m
		idStr = timebuf;

		// ID ۑ
		std::ofstream ofs;
		ofs.open(idFile);
		ofs << idStr;
		ofs.close();
	}

	return idStr;
}

// PNG t@CAbv[h.
BOOL uploadFile(HWND hwnd, LPCTSTR fileName)
{
	const TCHAR* UPLOAD_SERVER	= _T("gyazo.com");
	const TCHAR* UPLOAD_PATH	= _T("/upload.cgi");

	const char*  sBoundary = "----BOUNDARYBOUNDARY----";		// boundary
	const char   sCrLf[]   = { 0xd, 0xa, 0x0 };					// s(CR+LF)
	const TCHAR* szHeader  = 
		_T("Content-type: multipart/form-data; boundary=----BOUNDARYBOUNDARY----");

	std::ostringstream	buf;	// MbZ[W
	std::string			idStr;	// ID
	
	// ID 擾
	idStr = getId();

	// bZ[W̍\
	// -- "id" part
	buf << "--";
	buf << sBoundary;
	buf << sCrLf;
	buf << "content-disposition: form-data; name=\"id\"";
	buf << sCrLf;
	buf << sCrLf;
	buf << idStr;
	buf << sCrLf;

	// -- "imagedata" part
	buf << "--";
	buf << sBoundary;
	buf << sCrLf;
	buf << "content-disposition: form-data; name=\"imagedata\"";
	buf << sCrLf;
	//buf << "Content-type: image/png";	// ꉞ
	//buf << sCrLf;
	buf << sCrLf;

	// {: PNG t@Cǂݍ
	std::ifstream png;
	png.open(fileName, std::ios::binary);
	if (png.fail()) {
		MessageBox(hwnd, _T("png open failed"), _T("ERROR"), MB_ICONERROR | MB_OK);
		png.close();
		return FALSE;
	}
	buf << png.rdbuf();		// read all & append to buffer
	png.close();

	// Ō
	buf << sCrLf;
	buf << "--";
	buf << sBoundary;
	buf << "--";
	buf << sCrLf;

	// bZ[W
	std::string oMsg(buf.str());

	// WinInet  (proxy  K̐ݒ𗘗p)
	HINTERNET hSession    = InternetOpen(szTitle, 
		INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
	if(NULL == hSession) {
		MessageBox(hwnd, _T("cannot configure wininet"),
			_T("Error"), MB_ICONERROR | MB_OK);
		return FALSE;
	}
	
	// ڑ
	HINTERNET hConnection = InternetConnect(hSession, 
		UPLOAD_SERVER, INTERNET_DEFAULT_HTTP_PORT,
		NULL, NULL, INTERNET_SERVICE_HTTP, 0, NULL);
	if(NULL == hSession) {
		MessageBox(hwnd, _T("cannot initiate connection"),
			_T("Error"), MB_ICONERROR | MB_OK);
		return FALSE;
	}

	// v̐ݒ
	HINTERNET hRequest    = HttpOpenRequest(hConnection,
		_T("POST"), UPLOAD_PATH, NULL,
		NULL, NULL, INTERNET_FLAG_DONT_CACHE | INTERNET_FLAG_RELOAD, NULL);
	if(NULL == hSession) {
		MessageBox(hwnd, _T("cannot compose post request"),
			_T("Error"), MB_ICONERROR | MB_OK);
		return FALSE;
	}
	
	// v𑗐M
	if (HttpSendRequest(hRequest,
                    szHeader,
					lstrlen(szHeader),
                    (LPVOID)oMsg.c_str(),
					(DWORD) oMsg.length()))
	{
		// v͐
		
		DWORD resLen = 8;
		TCHAR resCode[8];

		// status code 擾
		HttpQueryInfo(hRequest, HTTP_QUERY_STATUS_CODE, resCode, &resLen, 0);
		if( _ttoi(resCode) != 200 ) {
			// upload s (status error)
			MessageBox(hwnd, _T("failed to upload (unexpected result code, under maintainance?)"),
				_T("Error"), MB_ICONERROR | MB_OK);
		} else {
			// upload C (URL) ǎ
			DWORD len;
			char  resbuf[1024];
			std::string result;
			
			// ȂɒƂ͂Ȃǂ܂ꉞ
			while(InternetReadFile(hRequest, (LPVOID) resbuf, 1024, &len) 
				&& len != 0)
			{
				result.append(resbuf, len);
			}

			// 擾ʂ NULL terminate ĂȂ̂
			result += '\0';

			// Nbv{[h URL Rs[
			setClipBoardText(result.c_str());
			
			// URL N
			execUrl(result.c_str());

			return TRUE;
		}
	} else {
		// Abv[hs...
		MessageBox(hwnd, _T("failed to upload"), _T("Error"), MB_ICONERROR | MB_OK);
	}

	return FALSE;

}